#ifndef __WIN32BIT__

/* 16 bit defs */
#include <string.h>
#define GET_FAR(x)		    (x)
#define PUT_FAR(x,v)		    (x=v)
#define PUT_FAR_LONG(x,v)	    (x=v)
#define LSRCCPY(dest,src,bytes)     _fmemcpy(dest,(void far *)src,bytes)
#define LDSTCPY(dest,src,bytes)     _fmemcpy((void far *)dest,src,bytes)
#define LSTRCPY(src,dest)	    _fstrcpy(src,dest)
#define STR2LONG(addr)		    (LONG)(LPSTR)(addr)
#else

/* 32 bit defs */
#define GET_FAR(x)		    _get_member(&(x))
#define PUT_FAR(x,v)		    _set_member_short(&(x),v)
#define PUT_FAR_LONG(x,v)	    _set_member_long(&(x),v)
#define LSRCCPY(dest,src,bytes)     _memcpy_from_far(dest,(unsigned long)src,bytes)
#define LDSTCPY(dest,src,bytes)     _memcpy_to_far((unsigned long)dest,src,bytes)
#define LSTRCPY(dest,src)	    _strcpy_from_far(dest,(unsigned long)src)
#define STR2LONG(addr)		    _convert_farp(addr)



/* 32 bit implementation */

void * _memcpy_from_far(void *offset32, unsigned long far16, unsigned short bytes);
void * _memcpy_to_far(unsigned long far16, void *offset32, unsigned short bytes);
void * _strcpy_from_far(void *offset32, unsigned long far16);
unsigned long _convert_farp(void * addr);
void * _unconvert_farp(unsigned long fp);

static inline unsigned long _get_member(void *addr)
{
    register unsigned long _v;

    __asm__("movw   %1, %%fs \n\t"
	    "movl   %%fs:%2 ,%0 \n\t"
		: "=r" (_v)
		: "r" ((unsigned short)((unsigned)addr>>16))
		 ,"m" (*(unsigned *)((int)addr&0xFFFF))
	    );
    return _v;
}
static inline void _set_member_long(void *addr, unsigned long value)
{
    __asm__("movw   %0, %%fs \n\t"
	    "movl   %2, %%fs:%1 \n\t"
		:
		: "r" ((unsigned short)((unsigned)addr>>16))
		 ,"m" (*(unsigned *)((int)addr&0xFFFF))
		 ,"r" (value)
	    );
}
static inline void _set_member_short(void *addr, unsigned short value)
{
    __asm__("movw   %0, %%fs \n\t"
	    "movw   %2, %%fs:%1 \n\t"
		:
		: "r" ((unsigned short)((unsigned)addr>>16))
		 ,"m" (*(unsigned *)((int)addr&0xFFFF))
		 ,"r" (value)
	    );
}

#endif
