#ifndef _SYSCALL_H

#include <alloca.h>

typedef unsigned short USHORT;
typedef unsigned long ULONG;
typedef unsigned short * stackw;
typedef long (*LONGCALLBACK)();

ULONG _wincall(ULONG fnct, ULONG module, ULONG param, char count);
int init_selector(int * sel);
int make_selector(int sel, void *pointer32);
int free_selector(int sel);
unsigned long _convert_farp(void * addr);
void * _unconvert_farp(unsigned long fp);

extern ULONG callback16;

#define INT_RESOURCE 0xFFFF

#define M_WINMAIN_INIT      0
#define M_LOAD_WNDFNCT	    1
#define M_LOAD_ENUMFNCT     2
#define M_LOAD_ENUMFONTS    3
#define M_LOAD_LINEDDA	    4
#define M_LOAD_ENUMMETA     5
#define M_LOAD_ENUMOBJ	    6
#define M_LOAD_GRAYSTRING   7
#define M_LOAD_ESCAPEABORT  8

#define MAGIC_INIT  0
#define USER        1
#define GDI         2
#define KERNEL      3
#define KEYBOARD    4
#define SOUND       5
#define COMM        6
#define TOOLHELP    7
#define COMMDLG     8
#define SHELL       9

/* --- stack parameter --- */
#define NOSTACK unsigned _st=0; char _count=0
#define STACKWORDS(words) \
    stackw _st = (stackw) alloca( (words) * sizeof(USHORT)); \
    void *_ps = _st; \
    char _count = words

extern int sel1;
extern int sel2;
extern int sel3;
extern int sel4;
extern int sel5;
/* --- push parameter --- */
#define PUSH_WORD(ARG)      *((USHORT *)_ps)++ = (USHORT)(ARG)
#define PUSH_LONG(ARG)      *((ULONG *)_ps)++ = ((ARG)>>16)|((ARG)<<16)
#define PUSH_LPNULL         *((ULONG *)_ps)++ = 0
#define PUSH_LPSTR1(ARG)    if (ARG) {  make_selector(sel1,(ARG)); \
                                        PUSH_WORD(sel1); \
                                        PUSH_WORD(0); } \
                            else { PUSH_LPNULL; }
#define PUSH_LPSTR2(ARG)    if (ARG) {  make_selector(sel2,(ARG)); \
                                        PUSH_WORD(sel2); \
                                        PUSH_WORD(0); } \
                            else { PUSH_LPNULL; }
#define PUSH_LPSTR3(ARG)    if (ARG) {  make_selector(sel3,(ARG)); \
                                        PUSH_WORD(sel3); \
                                        PUSH_WORD(0); } \
                            else { PUSH_LPNULL; }
#define PUSH_LPSTR4(ARG)    if (ARG) {  make_selector(sel4,(ARG)); \
                                        PUSH_WORD(sel4); \
                                        PUSH_WORD(0); } \
                            else { PUSH_LPNULL; }

/* --- call parameter --- */
#define WINCALL(fnc,mod)    _wincall(fnc, mod, (unsigned)_st, _count)
#define SV_CALL(fnc,par)    _wincall(fnc, MAGIC_INIT, par, 0)

#endif
