/* Rainer Schnitker
**
** generate syscall file
** for Windows functions
**
** call: HEADER windows.h > output
**
** note: only for 16bit compilers
*/

#include "c:\windev\include\windows.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "header1.h"
#include "header2.h"

FILE *fhandle;
char linebuf[512];
int done=0;

char *argp[50]; /* pointers in linebuf */
int argi[50];	/* index to data_types */
int args;	/* args in linebuf */

int return_arg;
int function_arg;
int first_arg;
int last_arg;
int fnct_args;
int function_index_windll;

int readline()
{
    int ch;
    int i=0;
    int args_now=0;
    int skip=0;

    for (;;) {
	ch = fgetc(fhandle);
	if (ch==EOF) {		/* file ends */
	    done=1;
	    if (i==0)
		return -1;
	    else {
		linebuf[i]=0;
		return i;
	    }
	}
	else if (ch=='\n') {    /* line ends */
	    linebuf[i]=0;
	    if (i<3) return 0;
	    return i;
	}
	else if ( ch=='(' || ch==')' ) {  /* check function args */
	    linebuf[i++]=' ';
	    linebuf[i++]=(char)ch ;
	    linebuf[i++]=' ';
	    if (ch == '(' )
		args_now = 1;
	    else
		args_now = 0;
	}
	else if (ch=='\t') {
	    linebuf[i++]=' ';
	}
	else if (ch==',') {
	    linebuf[i++]=' ';
	    skip = 0;
	}
	else if (args_now && skip==0 && ch>'A' && ch<'Z') {
	    linebuf[i++]=ch;
	    skip=1;
	}
	else if (args_now && skip==1 && ch>'a' && ch<'z') {
	    skip=2;
	}
	else if (skip!=2)
	    linebuf[i++]=(char)ch;
    }
}

static char str_short[]="short";

int maketokens()
{
    int i;
    char *argmem = linebuf;

    args = 0;

    argp[args++] = linebuf;
    for (i = 0; *(argmem + i) != 0; i++)
	if (*(argmem + i) == ' ') {
	    *(argmem + i) = 0;
	    if (*(argmem + i + 1) == ' ')
		continue;
	    if (*(argmem + i + 1) == 0)
		break;
	    /* 'FAR *' only in one arg */
	    if (argp[args-1][0]=='*' && strcmp(argp[args-2],"FAR")==0) {
		strcat(argp[args-3]," FAR *");
		args-=2;
	    }
	    argp[args++] = (argmem + i + 1);
	}
    argp[args] = 0;

    /* replace int with short! */
    for (i = 0; i < args; i++)
	if (strcmp(argp[i],"int")==0)
	    argp[i] = str_short;
    return 0;
}

static char voidfnct[]="void";

int findfunctionline()
{
    /* prototype is 'FAR' 'PASCAL' */
    if (!((args>5 && strcmp(argp[1],"FAR")==0 && strcmp(argp[2],"PASCAL")==0)))
	return 0;

    return_arg = 0;
    function_arg = 3;
    first_arg = 5;
    last_arg = args-3;
    if (last_arg == first_arg - 1) {
	argp[first_arg] = voidfnct;
	last_arg ++;
    }
    return 1;
}

int searchlist()
{
    int i,j;
    char *list, *current;

    for (i = first_arg; i <= last_arg ; i++) {
	current = argp[i];
	for ( j=0 ; ; j++) {
            list = data_types[j].name;
	    if (list == NULL) {
		printf("\nnot found '%s' in %s()\n\n", current, argp[function_arg]);
		return 0;
	    }
	    if (strcmp("FAR", current) == 0)
		break;
	    if (strcmp(list, current) == 0) {
		argi[i] = data_types[j].size;
		if (*current=='L' && *(current+1)=='P')
		    argi[i] = - data_types[j].size;
		break;
	    }
	}
    }

    current = argp[function_arg];
    for ( j=0 ; ; j++) {
	list = windows_dll[j].name;
	if (list == NULL) {
	    printf("\nfunction not found '%s'\n\n", current);
	    return 0;
	}
	if (stricmp(list, current) == 0) {
	    function_index_windll = j;
	    break;
	}
    }
    return 1;
}


int printbody()
{
    int i,size,sum=0,lpstr=0;

    printf("%s %s (", argp[return_arg],argp[function_arg]);
    for (i = first_arg; i < last_arg ; i++) {
        printf("%s par%d, ", argp[i], i-first_arg+1);
	sum += (((abs(argi[i]))>>1)<<1);
    }
    sum += (abs(argi[i]));
    if (sum)
	printf("%s par%d)\n" , argp[i], i-first_arg+1);
    else
	printf("%s)\n" , argp[i], i-first_arg+1);

    puts("{");
    if (sum) {
	printf("    STACKWORDS(");
	for (i = first_arg; i < last_arg ; i++) {
	    printf("%d+", (abs(argi[i])+1)>>1);
	}
	printf("%d);\n\n", (abs(argi[i])+1)>>1);
    }
    else
	printf("    NOSTACK;\n\n",sum);

    for (i = first_arg; i <= last_arg ; i++) {
	size = argi[i];
	if (size==1 || size==2)
	    printf("    PUSH_WORD(par%d);\n", i-first_arg+1);
	else if (size==4)
	    printf("    PUSH_LONG(par%d);\n", i-first_arg+1);
	else if (size < 0)
	    printf("    PUSH_LPSTR%d(par%d);\n", ++lpstr, i-first_arg+1);
    }

    if (strcmp(argp[return_arg],"void")==0 || strcmp(argp[return_arg],"VOID")==0)
	printf("    " );
    else
	printf("    return " );
    printf("WINCALL(%3d,%s);\n",
	    windows_dll[function_index_windll].fcntno,
	    windows_dll[function_index_windll].module);
    puts("}\n");
    return 0;
}

main(int argc, char **argv)
{
    if (argc<2) {
	puts("no header file");
	exit(1);
    }
    fhandle = fopen(argv[1], "rt");

    do {
	if (readline()<0) break;
	maketokens();
	if (findfunctionline())
	    if (searchlist())
		printbody();
    } while (!done);

    fclose(fhandle);
    return 0;
}
