#define NOUSER
#define NOGDI
#include <windows.h>
#include "syscall.h"

/* -------- KERNEL SECTION ----------------------------------- */

USHORT GetVersion(void)
{
    NOSTACK;
    return WINCALL(3,KERNEL);
}

HANDLE GetModuleHandle(LPSTR module_name)
{
    STACKWORDS(2);

    PUSH_LPSTR1(module_name);
    return WINCALL(47,KERNEL);
}

/*
** in syscall.c
** MakeProcInstance()
** WINCALL(51,KERNEL)
*/

/*
** in syscall.c
** FreeProcInstance()
** WINCALL(52,KERNEL)
*/

short GetInstanceData (HANDLE hInst, NPSTR pData, short nCount)
{
    /* WINCALL( 54,KERNEL);*/
    return 0;
}

short OpenFile(LPSTR file, LPOFSTRUCT of, WORD action)
{
    STACKWORDS(2+2+1);

    PUSH_LPSTR1(file);
    PUSH_LPSTR2(of);
    PUSH_WORD(action);
    return WINCALL(74,KERNEL);
}

short _lclose(short handle)
{
    STACKWORDS(1);

    PUSH_WORD(handle);
    return WINCALL(81,KERNEL);
}

WORD _lread(short handle, LPSTR buf, short bytes)
{
    STACKWORDS(1+2+1);

    PUSH_WORD(handle);
    PUSH_LPSTR1(buf);
    PUSH_WORD(bytes);
    return WINCALL(82,KERNEL);
}

short _lcreat(LPSTR file, short flags)
{
    STACKWORDS(2+1);

    PUSH_LPSTR1(file);
    PUSH_WORD(flags);
    return WINCALL(83,KERNEL);
}

LONG _llseek(short handle, long where, short fnct)
{
    STACKWORDS(1+2+1);

    PUSH_WORD(handle);
    PUSH_LONG(where);
    PUSH_WORD(fnct);
    return WINCALL(84,KERNEL);
}

short _lopen(LPSTR file, short flags)
{
    STACKWORDS(2+1);

    PUSH_LPSTR1(file);
    PUSH_WORD(flags);
    return WINCALL(85,KERNEL);
}

WORD _lwrite(short handle, LPSTR buf, short bytes)
{
    STACKWORDS(1+2+1);

    PUSH_WORD(handle);
    PUSH_LPSTR1(buf);
    PUSH_WORD(bytes);
    return WINCALL(86,KERNEL);
}

HANDLE LoadLibrary(LPSTR name)
{
    STACKWORDS(2);

    PUSH_LPSTR1(name);
    return WINCALL( 95,KERNEL);
}

void FreeLibrary(HANDLE hLib)
{
    STACKWORDS(1);

    PUSH_WORD(hLib);
    WINCALL( 96,KERNEL);
}

WORD GetNumTasks (void)
{
    NOSTACK;
    return WINCALL(152,KERNEL);
}

long GetWinFlags(void)
{
    NOSTACK;
    return WINCALL(132,KERNEL);
}


/* -------- KEYBOARD SECTION --------------------------------- */

short AnsiToOem(LPSTR buf1, LPSTR buf2)
{
    STACKWORDS(2+2);
    LPSTR buf = (buf1 < buf2) ? buf1 : buf2;
    int dif = (buf1 < buf2) ? (int)(buf2-buf1) : (int)(buf1-buf2);

    PUSH_LPSTR1(buf);
    PUSH_WORD(sel1); PUSH_WORD(dif);
    return WINCALL( 5, KEYBOARD);
}

BOOL OemToAnsi(LPSTR buf1, LPSTR buf2)
{
    STACKWORDS(2+2);
    LPSTR buf = (buf1 < buf2) ? buf1 : buf2;
    int dif = (buf1 < buf2) ? (int)(buf2-buf1) : (int)(buf1-buf2);

    PUSH_LPSTR1(buf);
    PUSH_WORD(sel1); PUSH_WORD(dif);
    return WINCALL( 6, KEYBOARD);
}

/* --------not tested ------------*/
/* --------not tested ------------*/
/* --------not tested ------------*/
/* --------not tested ------------*/

short GetProfileString (LPSTR par1, LPSTR par2, LPSTR par3, LPSTR par4, short par5)
{
    STACKWORDS(2+2+2+2+1);
    PUSH_LPSTR1(par1);
    PUSH_LPSTR2(par2);
    PUSH_LPSTR3(par3);
    PUSH_LPSTR4(par4);
    PUSH_WORD(par5);
    return WINCALL( 58,KERNEL);
}
short GetModuleFileName (HANDLE par1, LPSTR par2, short par3)
{
    STACKWORDS(1+2+1);

    PUSH_WORD(par1);
    PUSH_LPSTR1(par2);
    PUSH_WORD(par3);
    return WINCALL( 49,KERNEL);
}
FARPROC GetProcAddress(HANDLE par1, LPSTR par2)
{
    STACKWORDS(1+2);

    PUSH_WORD(par1);
    PUSH_LPSTR1(par2);
    return (FARPROC) WINCALL( 50,KERNEL);
}
