#define NOKERNEL
#define NOGDI
#include <windows.h>
#include "syscall.h"

/* -------- USER SECTION ------------------------------------- */

short MessageBox(HWND hWnd, LPSTR text, LPSTR title, WORD flags)
{
    STACKWORDS(1+2+2+1);

    PUSH_WORD(hWnd);
    PUSH_LPSTR1(text);
    PUSH_LPSTR2(title);
    PUSH_WORD(flags);
    return WINCALL(1,USER);
}

void PostQuitMessage(short exit_value)
{
    STACKWORDS(1);

    PUSH_WORD(exit_value);
    WINCALL(6,USER);
}

DWORD GetTickCount (void)
{
    NOSTACK;
    return WINCALL( 13,USER);
}

HWND SetCapture(HWND hWnd)
{
    STACKWORDS(1);

    PUSH_WORD(hWnd);
    return WINCALL( 18,USER);
}

void ReleaseCapture(void)
{
    NOSTACK;
    WINCALL( 19,USER);
}

void GetClientRect(HWND hWnd, LPRECT lpRect)
{
    STACKWORDS(1+2);

    PUSH_WORD(hWnd);
    PUSH_LPSTR1(lpRect);
    WINCALL( 33,USER);
}

BOOL EnableWindow(HWND hWnd,BOOL b)
{
    STACKWORDS(1+1);

    PUSH_WORD(hWnd);
    PUSH_WORD(b);
    return WINCALL( 34,USER);
}

void SetWindowText (HWND hWnd, LPSTR lpString)
{
    STACKWORDS(1+2);
    PUSH_WORD(hWnd);
    PUSH_LPSTR1(lpString);
    WINCALL( 37,USER);
}

HDC BeginPaint(HWND hWnd,LPPAINTSTRUCT lpPaint)
{
    STACKWORDS(1+2);

    PUSH_WORD(hWnd);
    PUSH_LPSTR1(lpPaint);
    return WINCALL(39,USER);
}

void EndPaint(HWND hWnd,LPPAINTSTRUCT lpPaint)
{
    STACKWORDS(1+2);

    PUSH_WORD(hWnd);
    PUSH_LPSTR1(lpPaint);
    WINCALL(40,USER);
}

/*
** in syscall.c
** CreateWindow()
** WINCALL(41,USER)
*/

BOOL ShowWindow(HWND hWnd, short att)
{
    STACKWORDS(1+1);

    PUSH_WORD(hWnd);
    PUSH_WORD(att);
    return WINCALL(42,USER);
}

BOOL DestroyWindow (HWND hWnd)
{
    STACKWORDS(1);
    PUSH_WORD(hWnd);
    return WINCALL( 53,USER);
}

BOOL EnumChildWindows(HWND hWnd, FARPROC callback_32, LONG lParam)
{
    STACKWORDS(1+2+2);
    ULONG cb16 = SV_CALL(M_LOAD_ENUMFNCT, (ULONG)callback_32);

    PUSH_WORD(hWnd);
    PUSH_LONG(cb16);
    PUSH_LONG(lParam);
    return WINCALL( 55,USER);
}

void MoveWindow (HWND hWnd, short x1, short y1, short x2, short y2, BOOL b)
{
    STACKWORDS(1+1+1+1+1+1);

    PUSH_WORD(hWnd);
    PUSH_WORD(x1);
    PUSH_WORD(y1);
    PUSH_WORD(x2);
    PUSH_WORD(y2);
    PUSH_WORD(b);
    WINCALL( 56,USER);
}

/*
** in syscall.c
** RegisterClass()
** WINCALL(57,USER)
*/

short GetClassName(HWND hWnd, LPSTR string, short len)
{
    STACKWORDS(1+2+1);

    PUSH_WORD(hWnd);
    PUSH_LPSTR1(string);
    PUSH_WORD(len);
    return WINCALL( 58,USER);
}

HWND GetActiveWindow(void)
{
    NOSTACK;
    return WINCALL(60,USER);
}

void ScrollWindow (HWND hWnd, short x, short y, LPRECT lpRect, LPRECT lpClipRect)
{
    STACKWORDS(1+1+1+2+2);

    PUSH_WORD(hWnd);
    PUSH_WORD(x);
    PUSH_WORD(y);
    PUSH_LPSTR1(lpRect);
    PUSH_LPSTR2(lpClipRect);
    WINCALL( 61,USER);
}

short SetScrollPos (HWND hWnd, short nBar, short nPos, BOOL bRedraw)
{
    STACKWORDS(1+1+1+1);

    PUSH_WORD(hWnd);
    PUSH_WORD(nBar);
    PUSH_WORD(nPos);
    PUSH_WORD(bRedraw);
    return WINCALL( 62,USER);
}

void SetScrollRange (HWND hWnd, short nBar, short nMin, short nMax, BOOL bRedraw)
{
    STACKWORDS(1+1+1+1+1);

    PUSH_WORD(hWnd);
    PUSH_WORD(nBar);
    PUSH_WORD(nMin);
    PUSH_WORD(nMax);
    PUSH_WORD(bRedraw);
    WINCALL( 64,USER);
}

HDC GetDC(HWND hWnd)
{
    STACKWORDS(1);

    PUSH_WORD(hWnd);
    return WINCALL(66,USER);
}

short ReleaseDC(HWND hWnd, HDC hdc)
{
    STACKWORDS(1+1);

    PUSH_WORD(hWnd);
    PUSH_WORD(hdc);
    return WINCALL(68,USER);
}

HCURSOR SetCursor(HCURSOR hcur)
{
    STACKWORDS(1);

    PUSH_WORD(hcur);
    return WINCALL( 69,USER);
}

short CopyRect (LPRECT lpDestRect, LPRECT lpSourceRect)
{
    STACKWORDS(2+2);

    PUSH_LPSTR1(lpDestRect);
    PUSH_LPSTR2(lpSourceRect);
    return WINCALL( 74,USER);
}

short DialogBox(HANDLE hInst, LPSTR name, HWND hWnd, FARPROC thunk)
{
    STACKWORDS(1+2+1+2);

    SV_CALL(M_LOAD_WNDFNCT, (ULONG)thunk);

    PUSH_WORD(hInst);
    if ((ULONG)name <= INT_RESOURCE)
        PUSH_LONG((ULONG)name);
    else
        PUSH_LPSTR1(name);
    PUSH_WORD(hWnd);
    PUSH_LONG(callback16);
    return WINCALL(87,USER);
}

void EndDialog(HWND hWnd, short ret)
{
    STACKWORDS(1+1);

    PUSH_WORD(hWnd);
    PUSH_WORD(ret);
    WINCALL(88,USER);
}

HWND CreateDialog(HANDLE hInst, LPSTR name, HWND hParent, FARPROC lpDlgProc)
{
    STACKWORDS(1+2+1+2);

    SV_CALL(M_LOAD_WNDFNCT, (ULONG)lpDlgProc);

    PUSH_WORD(hInst);
    if ((ULONG)name <= INT_RESOURCE)
        PUSH_LONG((ULONG)name);
    else
	PUSH_LPSTR1(name);
    PUSH_WORD(hParent);
    PUSH_LONG(callback16);
    return WINCALL( 89,USER);
}

HWND GetDlgItem(HWND hWnd, short id)
{
    STACKWORDS(1+1);

    PUSH_WORD(hWnd);
    PUSH_WORD(id);
    return WINCALL(91,USER);
}

void SetDlgItemText(HWND hWnd, short id, LPSTR text)
{
    STACKWORDS(1+1+2);

    PUSH_WORD(hWnd);
    PUSH_WORD(id);
    PUSH_LPSTR1(text);
    WINCALL( 92,USER);
}

short GetDlgItemText(HWND hWnd, short id, LPSTR text, short len)
{
    STACKWORDS(1+1+2+1);

    PUSH_WORD(hWnd);
    PUSH_WORD(id);
    PUSH_LPSTR1(text);
    PUSH_WORD(len);
    return WINCALL( 93,USER);
}

void CheckRadioButton(HWND hWnd, short id1, short id2, short id3)
{
    STACKWORDS(1+1+1+1);

    PUSH_WORD(hWnd);
    PUSH_WORD(id1);
    PUSH_WORD(id2);
    PUSH_WORD(id3);
    WINCALL( 96,USER);
}

void CheckDlgButton(HWND hDlg, short nID, WORD wCheck)
{
    STACKWORDS(1+1+1);

    PUSH_WORD(hDlg);
    PUSH_WORD(nID);
    PUSH_WORD(wCheck);
    WINCALL( 97,USER);
}

BOOL  DlgDirSelect(HWND hWnd, LPSTR name, short id)
{
    STACKWORDS(1+2+1);

    PUSH_WORD(hWnd);
    PUSH_LPSTR1(name);
    PUSH_WORD(id);
    return WINCALL(99,USER);
}

short DlgDirList(HWND hWnd, LPSTR name, short idbox, short id, WORD attr)
{
    STACKWORDS(1+2+1+1+1);

    PUSH_WORD(hWnd);
    PUSH_LPSTR1(name);
    PUSH_WORD(idbox);
    PUSH_WORD(id);
    PUSH_WORD(attr);
    return WINCALL(100,USER);
}

LONG SendDlgItemMessage(HWND hWnd, short id, WORD msg, WORD wp, LONG lp)
{
    STACKWORDS(1+1+1+1+2);

    PUSH_WORD(hWnd);
    PUSH_WORD(id);
    PUSH_WORD(msg);
    PUSH_WORD(wp);
    PUSH_LONG(lp);
    return WINCALL(101,USER);
}

void MessageBeep(WORD sound)
{
    STACKWORDS(1);

    PUSH_WORD(sound);
    WINCALL(104,USER);
}

LONG DefWindowProc(HWND hWnd, WORD msg, WORD wParam, LONG lParam)
{
    STACKWORDS(1+1+1+2);

    PUSH_WORD(hWnd);
    PUSH_WORD(msg);
    PUSH_WORD(wParam);
    PUSH_LONG(lParam);
    return WINCALL(107,USER);
}

BOOL GetMessage(LPMSG msg, HWND hWnd, WORD max, WORD min)
{
    STACKWORDS(2+1+1+1);

    PUSH_LPSTR1(msg);
    PUSH_WORD(hWnd);
    PUSH_WORD(max);
    PUSH_WORD(min);
    return WINCALL(108,USER);
}

BOOL PeekMessage(LPMSG msg, HWND hWnd, WORD max, WORD min, WORD remove)
{
    STACKWORDS(2+1+1+1+1);

    PUSH_LPSTR1(msg);
    PUSH_WORD(hWnd);
    PUSH_WORD(max);
    PUSH_WORD(min);
    PUSH_WORD(remove);
    return WINCALL(109,USER);
}

BOOL PostMessage(HWND hWnd, WORD msg, WORD wp, LONG lp)
{
    STACKWORDS(1+1+1+2);

    PUSH_WORD(hWnd);
    PUSH_WORD(msg);
    PUSH_WORD(wp);
    PUSH_LONG(lp);
    return WINCALL(110,USER);
}

/*
** in syscall.c
** SendMessage()
** WINCALL(111,USER)
*/

BOOL TranslateMessage(LPMSG msg)
{
    STACKWORDS(2);

    PUSH_LPSTR1(msg);
    return WINCALL(113,USER);
}

LONG DispatchMessage(LPMSG msg)
{
    STACKWORDS(2);

    PUSH_LPSTR1(msg);
    return WINCALL(114,USER);
}

void UpdateWindow(HWND hWnd)
{
    STACKWORDS(1);

    PUSH_WORD(hWnd);
    WINCALL(124,USER);
}

void InvalidateRect(HWND hWnd, LPRECT lpRect, BOOL b)
{
    STACKWORDS(1+2+1);

    PUSH_WORD(hWnd);
    PUSH_LPSTR1(lpRect);
    PUSH_WORD(b);
    WINCALL(125,USER);
}

HWND CreateDialogParam(HANDLE hInst, LPSTR name, HWND hParent, FARPROC lpDlgProc, LONG lParam)
{
    STACKWORDS(1+2+1+2+2);

    SV_CALL(M_LOAD_WNDFNCT, (ULONG)lpDlgProc);

    PUSH_WORD(hInst);
    if ((ULONG)name <= INT_RESOURCE)
        PUSH_LONG((ULONG)name);
    else
	PUSH_LPSTR1(name);
    PUSH_WORD(hParent);
    PUSH_LONG(callback16);
    PUSH_LONG(lParam);
    return WINCALL(241,USER);
}

HMENU LoadMenu(HANDLE hInstance, LPSTR name)
{
    STACKWORDS(1+2);

    PUSH_WORD(hInstance);
    if ((ULONG)name <= INT_RESOURCE)
        PUSH_LONG((ULONG)name);
    else
        PUSH_LPSTR1(name);
    return WINCALL(150,USER);
}

HMENU CreateMenu(void)
{
    NOSTACK;
    return WINCALL(151,USER);
}

BOOL DestroyMenu(HWND hWnd)
{
    STACKWORDS(1);

    PUSH_WORD(hWnd);
    return WINCALL(152,USER);
}

BOOL CheckMenuItem(HMENU hMenu, WORD menuitem, WORD check)
{
    STACKWORDS(1+1+1);

    PUSH_WORD(hMenu);
    PUSH_WORD(menuitem);
    PUSH_WORD(check);
    return WINCALL(154,USER);
}

BOOL EnableMenuItem(HMENU hmenu, WORD id, WORD att)
{
    STACKWORDS(1+1+1);

    PUSH_WORD(hmenu);
    PUSH_WORD(id);
    PUSH_WORD(att);
    return WINCALL(155,USER);
}

HMENU GetMenu(HWND hWnd)
{
    STACKWORDS(1);

    PUSH_WORD(hWnd);
    return WINCALL(157,USER);
}

BOOL SetMenu(HWND hWnd, HMENU hmenu)
{
    STACKWORDS(1+1);

    PUSH_WORD(hWnd);
    PUSH_WORD(hmenu);
    return WINCALL(158,USER);
}

void DrawMenuBar(HWND hWnd)
{
    STACKWORDS(1);

    PUSH_WORD(hWnd);
    WINCALL(160,USER);
}

HCURSOR LoadCursor(HANDLE hInst, LPSTR name)
{
    STACKWORDS(1+2);

    PUSH_WORD(hInst);
    if ((ULONG)name <= INT_RESOURCE)
        PUSH_LONG((ULONG)name);
    else
        PUSH_LPSTR1(name);
    return WINCALL(173,USER);
}

HICON LoadIcon(HANDLE hInst, LPSTR name)
{
    STACKWORDS(1+2);

    PUSH_WORD(hInst);
    if ((ULONG)name <= INT_RESOURCE)
        PUSH_LONG((ULONG)name);
    else
        PUSH_LPSTR1(name);
    return WINCALL(174,USER);
}

short DialogBoxParam(HANDLE hInst, LPSTR name, HWND hWnd, FARPROC thunk, LONG lParam)
{
    STACKWORDS(1+2+1+2+2);

    SV_CALL(M_LOAD_WNDFNCT, (ULONG)thunk);

    PUSH_WORD(hInst);
    if ((ULONG)name <= INT_RESOURCE)
        PUSH_LONG((ULONG)name);
    else
        PUSH_LPSTR1(name);
    PUSH_WORD(hWnd);
    PUSH_LONG(callback16);
    PUSH_LONG(lParam);
    return WINCALL(239,USER);
}

HWND GetDesktopWindow (void)
{
    NOSTACK;
    return WINCALL(286,USER);
}

BOOL AppendMenu(HMENU hmenu, WORD mf, WORD id, LPSTR title)
{
    STACKWORDS(1+1+1+2);

    PUSH_WORD(hmenu);
    PUSH_WORD(mf);
    PUSH_WORD(id);
    PUSH_LPSTR1(title);
    return WINCALL(411,USER);
}

HMENU CreatePopupMenu(void)
{
    NOSTACK;

    return WINCALL(415,USER);
}

LPSTR AnsiUpper (LPSTR string)
{
    STACKWORDS(2);
    ULONG ret;

    if ((ULONG) string <= 0xFFFF)
	PUSH_LONG((ULONG)string);
    else
	PUSH_LPSTR1(string);

    ret = (ULONG) WINCALL(431,USER);

    if ((ULONG)string <= 0xFFFF)
	return (LPSTR) ret;
    else
	return string;
}

LPSTR AnsiNext(LPSTR charpos)
{
    STACKWORDS(2);

    PUSH_LPSTR1(charpos);
    return (charpos + (WINCALL(472,USER)&0xFFFF));
}

LPSTR AnsiPrev(LPSTR begin,LPSTR charpos)
{
    STACKWORDS(2+2);

    PUSH_LPSTR1(begin);
    PUSH_WORD(sel1);PUSH_WORD((ULONG)(charpos-begin));

    return (begin + (WINCALL(473,USER)&0xFFFF));
}

/* --------not tested ------------*/
/* --------not tested ------------*/
/* --------not tested ------------*/
/* --------not tested ------------*/

LONG DefFrameProc (HWND par1, HWND par2, WORD par3, WORD par4, LONG par5)
{
    STACKWORDS(1+1+1+1+2);

    PUSH_WORD(par1);
    PUSH_WORD(par2);
    PUSH_WORD(par3);
    PUSH_WORD(par4);
    PUSH_LONG(par5);
    return WINCALL(445,USER);
}
LONG DefMDIChildProc (HWND par1, WORD par2, WORD par3, LONG par4)
{
    STACKWORDS(1+1+1+2);

    PUSH_WORD(par1);
    PUSH_WORD(par2);
    PUSH_WORD(par3);
    PUSH_LONG(par4);
    return WINCALL(447,USER);
}
short FillRect (HDC par1, LPRECT par2, HBRUSH par3)
{
    STACKWORDS(1+2+1);

    PUSH_WORD(par1);
    PUSH_LPSTR1(par2);
    PUSH_WORD(par3);
    return WINCALL( 81,USER);
}
short FrameRect (HDC par1, LPRECT par2, HBRUSH par3)
{
    STACKWORDS(1+2+1);

    PUSH_WORD(par1);
    PUSH_LPSTR1(par2);
    PUSH_WORD(par3);
    return WINCALL( 83,USER);
}
WORD GetDlgItemInt (HWND par1, short par2, BOOL *par3, BOOL par4)
{
    STACKWORDS(1+1+2+1);

    PUSH_WORD(par1);
    PUSH_WORD(par2);
    PUSH_LPSTR1(par3);
    PUSH_WORD(par4);
    return WINCALL( 95,USER);
}
HWND GetParent (HWND par1)
{
    STACKWORDS(1);

    PUSH_WORD(par1);
    return WINCALL( 46,USER);
}
HMENU GetSubMenu (HMENU par1, short par2)
{
    STACKWORDS(1+1);
    PUSH_WORD(par1);
    PUSH_WORD(par2);
    return WINCALL(159,USER);
}
DWORD GetSysColor (short par1)
{
    STACKWORDS(1);
    PUSH_WORD(par1);
    return WINCALL(180,USER);
}
HMENU GetSystemMenu (HWND par1, BOOL par2)
{
    STACKWORDS(1+1);
    PUSH_WORD(par1);
    PUSH_WORD(par2);
    return WINCALL(156,USER);
}
HWND GetWindow (HWND par1, WORD par2)
{
    STACKWORDS(1+1);
    PUSH_WORD(par1);
    PUSH_WORD(par2);
    return WINCALL(262,USER);
}
void GetWindowRect (HWND par1, LPRECT par2)
{
    STACKWORDS(1+2);
    PUSH_WORD(par1);
    PUSH_LPSTR1(par2);
    WINCALL( 32,USER);
}
WORD GetWindowWord (HWND par1, short par2)
{
    STACKWORDS(1+1);
    PUSH_WORD(par1);
    PUSH_WORD(par2);
    return WINCALL(133,USER);
}
void InflateRect (LPRECT par1, short par2, short par3)
{
    STACKWORDS(2+1+1);

    PUSH_LPSTR1(par1);
    PUSH_WORD(par2);
    PUSH_WORD(par3);
    WINCALL( 78,USER);
}
short IntersectRect (LPRECT par1, LPRECT par2, LPRECT par3)
{
    STACKWORDS(2+2+2);

    PUSH_LPSTR1(par1);
    PUSH_LPSTR2(par2);
    PUSH_LPSTR3(par3);
    return WINCALL( 79,USER);
}
BOOL IsDialogMessage (HWND par1, LPMSG par2)
{
    STACKWORDS(1+2);

    PUSH_WORD(par1);
    PUSH_LPSTR1(par2);
    return WINCALL( 90,USER);
}
WORD IsDlgButtonChecked (HWND par1, short par2)
{
    STACKWORDS(1+1);

    PUSH_WORD(par1);
    PUSH_WORD(par2);
    return WINCALL( 98,USER);
}
HANDLE LoadAccelerators (HANDLE par1, LPSTR par2)
{
    STACKWORDS(1+2);

    PUSH_WORD(par1);
    PUSH_LPSTR1(par2);
    return WINCALL(177,USER);
}
short LoadString (HANDLE par1, WORD par2, LPSTR par3, short par4)
{
    STACKWORDS(1+1+2+1);

    PUSH_WORD(par1);
    PUSH_WORD(par2);
    PUSH_LPSTR1(par3);
    PUSH_WORD(par4);
    return WINCALL(176,USER);
}
void SetDlgItemInt (HWND par1, short par2, WORD par3, BOOL par4)
{
    STACKWORDS(1+1+1+1);

    PUSH_WORD(par1);
    PUSH_WORD(par2);
    PUSH_WORD(par3);
    PUSH_WORD(par4);
    WINCALL( 94,USER);
}
HWND SetFocus (HWND par1)
{
    STACKWORDS(1);

    PUSH_WORD(par1);
    return WINCALL( 22,USER);
}
void SetWindowPos (HWND par1, HWND par2, short par3, short par4, short par5, short par6, WORD par7)
{
    STACKWORDS(1+1+1+1+1+1+1);

    PUSH_WORD(par1);
    PUSH_WORD(par2);
    PUSH_WORD(par3);
    PUSH_WORD(par4);
    PUSH_WORD(par5);
    PUSH_WORD(par6);
    PUSH_WORD(par7);
    WINCALL(232,USER);
}
WORD SetWindowWord (HWND par1, short par2, WORD par3)
{
    STACKWORDS(1+1+1);

    PUSH_WORD(par1);
    PUSH_WORD(par2);
    PUSH_WORD(par3);
    return WINCALL(134,USER);
}
short TranslateAccelerator (HWND par1, HANDLE par2, LPMSG par3)
{
    STACKWORDS(1+1+2);

    PUSH_WORD(par1);
    PUSH_WORD(par2);
    PUSH_LPSTR1(par3);
    return WINCALL(178,USER);
}
BOOL TranslateMDISysAccel (HWND par1, LPMSG par2)
{
    STACKWORDS(1+2);

    PUSH_WORD(par1);
    PUSH_LPSTR1(par2);
    return WINCALL(451,USER);
}
