#define NOGDICAPMASKS		/* CC_~, LC_~, PC_~, CP_~, TC_~, RC_*/
#define NOSYSMETRICS		/* SM_~				    */
#define NOKEYSTATES		/* MK_~				    */
#define NOSYSCOMMANDS		/* SC_~				    */
#define NORASTEROPS		/* Binary and Tertiary raster ops   */
#define OEMRESOURCE		/* OEM Resource values		    */
#define NOATOM			/* Atom Manager routines	    */
#define NOCLIPBOARD		/* Clipboard routines 		    */
#define NOCOLOR 		/* Screen colors		    */
#define NOMETAFILE		/* typedef METAFILEPICT		    */
#define NOSOUND 		/* Sound driver routines	    */
#define NOWH			/* SetWindowsHook and WH_~	    */
#define NOWINOFFSETS		/* GWL_~, GCL_~, associated routines*/
#define NOCOMM			/* COMM driver routines		    */
#define NOKANJI			/* Kanji support stuff.		    */
#define NOHELP			/* Help engine interface.	    */
#define NOPROFILER		/* Profiler interface.		    */
#define NODEFERWINDOWPOS	/* DeferWindowPos routines	    */

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "dlgtst.h"

static char szAppname[]="dlgtst";
static HWND hWindow;
static hInst;
FARPROC lpproc;

BOOL FAR PASCAL _export About(HWND hDlg, WORD message, WORD wParam, LONG lParam)
{
    if (message == WM_INITDIALOG)
	return (TRUE);

    else if (message == WM_COMMAND) {
	switch (wParam) {
	case IDOK:
	    EndDialog(hDlg, TRUE);
	    return (TRUE);

	default:
	    return (TRUE);
	}
    }
    return (FALSE);
}

long FAR PASCAL _export WndProc(HWND hWnd, WORD message, WORD wParam, LONG lParam)
{
    HANDLE hAboutDlg;

    switch (message) {

    case WM_DESTROY:
	FreeProcInstance(lpproc);
	PostQuitMessage(0);
	break;

    case WM_COMMAND:
	switch (wParam) {
	case IDM_ABOUT:
	    hAboutDlg=CreateDialog(hInst,"ABOUT",hWnd,lpproc);
	    ShowWindow(hAboutDlg,SW_SHOWNORMAL);
	    break;
	}
	break;

    default:
	return (DefWindowProc(hWnd, message, wParam, lParam));
    }
    return (0L);
}

BOOL InitApplication(HANDLE hInstance)
{
    WNDCLASS wc;

    wc.style = NULL;
    wc.lpfnWndProc = WndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = GetStockObject(WHITE_BRUSH); 
    wc.lpszMenuName =  szAppname;
    wc.lpszClassName = szAppname;
    
    return RegisterClass(&wc);
}

BOOL InitInstance(HANDLE hInstance,int nCmdShow)
{
    hWindow = CreateWindow(
	szAppname,
	"DIALOG TEST",
	WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
	NULL, NULL,
	hInstance,
	NULL);

    if (!hWindow)
        return (NULL);

    lpproc = MakeProcInstance((FARPROC) About, hInst);

    ShowWindow(hWindow, nCmdShow);
    UpdateWindow(hWindow);

    return TRUE;
}

int PASCAL _export
WinMain(HANDLE hInstance, HANDLE hPrevInst, LPSTR lpszCmdParam, int nCmdShow)
{
    MSG msg;
    
    hInst = hInstance;

    if (hPrevInst) {
	MessageBox(NULL,"only one instance",NULL,MB_OK);
        return (FALSE);
    }
    if (!InitApplication(hInstance)) {
	MessageBox(NULL,"register class",NULL,MB_OK);
        return (FALSE);
    }
    if (!InitInstance(hInstance, nCmdShow)) {
	MessageBox(NULL,"create window",NULL,MB_OK);
        return (FALSE);
    }
    
    while (GetMessage(&msg, NULL, 0, 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    return msg.wParam;
}
