#define NOGDICAPMASKS	  /* CC_~, LC_~, PC_~, CP_~, TC_~, RC_	    */
#define NOVIRTUALKEYCODES /* VK_~				    */
#define NOWINMESSAGES	  /* WM_~, EM_~, LB_~, CB_~		    */
#define NOWINSTYLES	  /* WS_~, CS_~, ES_~, LBS_~, SBS_~, CBS_~  */
#define NOSYSMETRICS	  /* SM_~				    */
#define NOMENUS 	  /* MF_~				    */
#define NOICONS 	  /* IDI_~				    */
#define NOKEYSTATES	  /* MK_~				    */
#define NOSYSCOMMANDS	  /* SC_~				    */
#define NORASTEROPS	  /* Binary and Tertiary raster ops	    */
#define NOSHOWWINDOW	  /* SW_~				    */
#define OEMRESOURCE	  /* OEM Resource values		    */
#define NOATOM		  /* Atom Manager routines		    */
#define NOCLIPBOARD	  /* Clipboard routines 		    */
#define NOCOLOR 	  /* Screen colors			    */
#define NOCTLMGR	  /* Control and Dialog routines	    */
#define NODRAWTEXT	  /* DrawText() and DT_~		    */
#define NOGDI		  /* All GDI defines and routines	    */
#define NOMEMMGR	  /* GMEM_~, LMEM_~, GHND, LHND 	    */
#define NOMETAFILE	  /* typedef METAFILEPICT		    */
#define NOMINMAX	  /* Macros min(a,b) and max(a,b)	    */
#define NOMSG		  /* typedef MSG and associated routines    */
#define NOOPENFILE	  /* OpenFile(), OemToAnsi,  and OF_~	    */
#define NOSCROLL	  /* SB_~ and scrolling routines	    */
#define NOSOUND 	  /* Sound driver routines		    */
#define NOTEXTMETRIC	  /* typedef TEXTMETRIC and assoc. routines */
#define NOWH		  /* SetWindowsHook and WH_~		    */
#define NOWINOFFSETS	  /* GWL_~, GCL_~, associated routines	    */
#define NOCOMM		  /* COMM driver routines		    */
#define NOKANJI 	  /* Kanji support stuff.		    */
#define NOHELP		  /* Help engine interface.		    */
#define NOPROFILER	  /* Profiler interface.		    */
#define NODEFERWINDOWPOS  /* DeferWindowPos routines		    */

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dll16.h"
#include "dll32.h"

#ifdef __EMX__
#define wsprintf sprintf
#endif

typedef int (FAR PASCAL *DLLFUNC)(LPSTR);

static char app_name[] = "dlltst";
static char dll[] = "DLL16.DLL";

static char dll_name[260];

int PASCAL WinMain(HANDLE hInst, HANDLE hPrevInst, LPSTR lpszCmd, int nCmdShow)
{
    char buf[512];
    DLLFUNC lpFunc;
    HANDLE hLib;
    int i;

    GetModuleFileName(hInst, dll_name, 260);

    for (i=0; dll_name[i]; i++)
	if (dll_name[i]=='.')
	    break;
    for ( ; i>0 ; i--)
	if (dll_name[i]=='\\') {
	    dll_name[i+1]=0;
	    break;
	}
    strcat(dll_name, dll);

    sprintf(buf, "DLL = %s", dll_name);
    MessageBox(NULL, buf, app_name, MB_OK);

    hLib = LoadLibrary(dll_name);
    if (hLib < 32) {
	MessageBox(NULL, "can't find dll", app_name, MB_OK);
	return 1;
    }

#ifndef __EMX__
    lpFunc = (DLLFUNC)
	GetProcAddress(hLib, MAKEINTRESOURCE( CHANGE_STRING ));
#else
    lpFunc = (DLLFUNC)
	GetProc32Address(hLib, (FARPROC) ChangeString);
#endif

    if (lpFunc == NULL) {
	MessageBox(NULL, "can't find procaddress", app_name, MB_OK);
	return 1;
    }

    sprintf(buf, "Hello Windows");
    MessageBox(NULL, buf, app_name, MB_OK);

    (*lpFunc) (buf);
    MessageBox(NULL, buf, app_name, MB_OK);

    return 0;
}
