#define NOGDICAPMASKS     /* CC_~, LC_~, PC_~, CP_~, TC_~, RC_      */
#define NOVIRTUALKEYCODES /* VK_~				    */
#define NOSYSMETRICS	  /* SM_~				    */
#define NOMENUS 	  /* MF_~				    */
#define NOKEYSTATES	  /* MK_~				    */
#define NOSYSCOMMANDS	  /* SC_~				    */
#define NORASTEROPS	  /* Binary and Tertiary raster ops	    */
#define NOSHOWWINDOW	  /* SW_~				    */
#define OEMRESOURCE	  /* OEM Resource values		    */
#define NOATOM		  /* Atom Manager routines		    */
#define NOCLIPBOARD	  /* Clipboard routines 		    */
#define NOCOLOR 	  /* Screen colors			    */
#define NODRAWTEXT	  /* DrawText() and DT_~		    */
#define NOMEMMGR	  /* GMEM_~, LMEM_~, GHND, LHND 	    */
#define NOMETAFILE	  /* typedef METAFILEPICT		    */
#define NOMINMAX	  /* Macros min(a,b) and max(a,b)	    */
#define NOOPENFILE	  /* OpenFile(), OemToAnsi,  and OF_~	    */
#define NOSCROLL	  /* SB_~ and scrolling routines	    */
#define NOSOUND 	  /* Sound driver routines		    */
#define NOWH		  /* SetWindowsHook and WH_~		    */
#define NOWINOFFSETS	  /* GWL_~, GCL_~, associated routines	    */
#define NOCOMM		  /* COMM driver routines		    */
#define NOKANJI 	  /* Kanji support stuff.		    */
#define NOHELP		  /* Help engine interface.		    */
#define NOPROFILER	  /* Profiler interface.		    */
#define NODEFERWINDOWPOS  /* DeferWindowPos routines		    */

#include <windows.h>
#include "\rsxwin\include\port.h"
#include <stdio.h>

static FARPROC enum_w;
static char szAppname[]="enumw";
static HWND hWindow, hListWnd;

#define WM_USER_START  WM_USER+1

BOOL _export FAR PASCAL
EnumW(LPLOGFONT lpFont, LPTEXTMETRIC lpTM, short x, LPSTR str)
{
    BYTE szFaceName[LF_FACESIZE];

    LSRCCPY( szFaceName, lpFont->lfFaceName, sizeof(szFaceName));
    SendMessage(hListWnd, LB_ADDSTRING, NULL, STR2LONG(szFaceName));
    return 1;
}

long FAR PASCAL _export WndProc(HWND hwnd, WORD message, WORD wParam, LONG lParam)
{
    HDC hdc;

    switch (message)
    {
	case WM_USER_START:
	    hdc = GetDC(hwnd);
	    EnumFonts(hdc, NULL, enum_w, NULL);
	    ReleaseDC(hwnd, hdc);

	    InvalidateRect(hListWnd,NULL,TRUE);
	    SendMessage(hListWnd,WM_SETREDRAW,1,NULL);
	    UpdateWindow(hListWnd);
	    break;
            
	case WM_SIZE:
	    MoveWindow(hListWnd,0, 0,LOWORD(lParam),HIWORD(lParam),TRUE);
            break;

        case WM_DESTROY:
	    FreeProcInstance(enum_w);
	    SendMessage(hListWnd,LB_RESETCONTENT,NULL,NULL);
            PostQuitMessage(0);
	    break;
            
        default:
            return DefWindowProc(hwnd, message, wParam, lParam);
    }
    return 0;
}

BOOL InitApplication(HANDLE hInstance)
{
    WNDCLASS wc;

    wc.style = NULL;
    wc.lpfnWndProc = WndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = GetStockObject(WHITE_BRUSH); 
    wc.lpszMenuName =  NULL;
    wc.lpszClassName = szAppname;
    
    return RegisterClass(&wc);
}

BOOL InitInstance(HANDLE hInstance,int nCmdShow)
{
    RECT Rect;

    enum_w = MakeProcInstance((FARPROC) EnumW, hInstance);

    hWindow = CreateWindow(
	szAppname,
	"ENUM TEST",
	WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
	NULL, NULL,
	hInstance,
	NULL);

    if (!hWindow)
        return (NULL);

    hListWnd = CreateWindow(
	"Listbox",
	NULL ,
	LBS_STANDARD | LBS_HASSTRINGS | LBS_NOREDRAW |
	WS_VISIBLE | WS_BORDER | WS_VSCROLL | WS_CHILD,
	0, 0, Rect.right-Rect.left, Rect.bottom-Rect.top,
	hWindow, NULL,
	hInstance,
	NULL);

    if (!hListWnd) {
        DestroyWindow(hWindow);
        return (NULL);
    }

    SendMessage(hWindow,WM_USER_START,0,0L);

    ShowWindow(hWindow, nCmdShow);
    UpdateWindow(hWindow);

    return TRUE;
}

int PASCAL _export
WinMain(HANDLE hInstance, HANDLE hPrevInst, LPSTR lpszCmdParam, int nCmdShow)
{
    MSG msg;
    
    if (hPrevInst) {
	MessageBox(NULL,"only one instance",NULL,MB_OK);
        return (FALSE);
    }
    if (!InitApplication(hInstance)) {
	MessageBox(NULL,"register class",NULL,MB_OK);
        return (FALSE);
    }
    if (!InitInstance(hInstance, nCmdShow)) {
	MessageBox(NULL,"create window",NULL,MB_OK);
        return (FALSE);
    }
    
    while (GetMessage(&msg, NULL, 0, 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    return msg.wParam;
}
