#define NOGDICAPMASKS		/* CC_~, LC_~, PC_~, CP_~, TC_~, RC_*/
#define NOSYSMETRICS		/* SM_~				    */
#define NOKEYSTATES		/* MK_~				    */
#define NOSYSCOMMANDS		/* SC_~				    */
#define NORASTEROPS		/* Binary and Tertiary raster ops   */
#define OEMRESOURCE		/* OEM Resource values		    */
#define NOATOM			/* Atom Manager routines	    */
#define NOCLIPBOARD		/* Clipboard routines 		    */
#define NOCOLOR 		/* Screen colors		    */
#define NOMETAFILE		/* typedef METAFILEPICT		    */
#define NOSOUND 		/* Sound driver routines	    */
#define NOWH			/* SetWindowsHook and WH_~	    */
#define NOWINOFFSETS		/* GWL_~, GCL_~, associated routines*/
#define NOCOMM			/* COMM driver routines		    */
#define NOKANJI			/* Kanji support stuff.		    */
#define NOHELP			/* Help engine interface.	    */
#define NOPROFILER		/* Profiler interface.		    */
#define NODEFERWINDOWPOS	/* DeferWindowPos routines	    */

#ifdef __EMX__
#include <sys\emx.h>
#define find_t _find
#define _dos_findfirst __findfirst
#endif

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include <io.h>
#include <dos.h>
#include "hdump.h"

#ifndef __EMX__
#include <direct.h>
#endif

typedef struct scrollkeys {
    WORD wVirtkey;
    int iMessage;
    WORD wRequest;
} SCROLLKEYS;

SCROLLKEYS key2scroll[] =
{
    VK_HOME, WM_COMMAND, IDM_HOME,
    VK_END, WM_VSCROLL, SB_BOTTOM,
    VK_PRIOR, WM_VSCROLL, SB_PAGEUP,
    VK_NEXT, WM_VSCROLL, SB_PAGEDOWN,
    VK_UP, WM_VSCROLL, SB_LINEUP,
    VK_DOWN, WM_VSCROLL, SB_LINEDOWN,
    VK_LEFT, WM_HSCROLL, SB_PAGEUP,
    VK_RIGHT, WM_HSCROLL, SB_PAGEDOWN
};

#define NUMKEYS (sizeof key2scroll / sizeof key2scroll[0])

char szAppName[] = "hdump";

HANDLE hInst;
HWND hWndMain;

int xChar, yChar, yCharnl;
int xClient, yClient;

LOGFONT cursfont;
HANDLE holdsfont;
HANDLE hnewsfont;

int nVscrollMax, nHscrollMax;
int nVscrollPos, nHscrollPos;
int numlines;
int maxwidth;
int nVscrollInc, nHscrollInc;
int nPageMaxLines;

char szFileSpec[80];
char szDefExt[5];
char szFileName[80];
char szFilePath[80];
WORD wFileAttr;
WORD wStatus;

char szFName[64];
FILE *fh;
LONG fsize;


int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance,
		    LPSTR lpszCmdLine, int cmdShow);

void InitHdump(HANDLE hInstance, HANDLE hPrevInstance,
	        LPSTR lpszCmdLine, int cmdShow);
void InitHdumpFirst(HANDLE hInstance);
void InitHdumpAdded(HANDLE hPrevInstance);
void InitHdumpEvery(HANDLE hInstance, int cmdShow);
void CloseHdump(void);
BOOL FAR PASCAL About(HWND hDlg, WORD message, WORD wParam, LONG lParam);

long FAR PASCAL HdumpWndProc(HWND hWnd, WORD message,
			      WORD wParam, LONG lParam);

void SetupScroll(HWND hWnd);
void HdumpPaint(HWND hWnd);
char *SnapLine(char *szBuf, LPSTR mem, int len,
	        int dwid, char *olbl);

int DoFileOpenDlg(HANDLE hInst, HWND hWnd,
		   char *szFileSpecIn, char *szDefExtIn,
		   WORD wFileAttrIn,
		   char *szFilePathOut, char *szFileNameOut);
extern BOOL FAR PASCAL FileOpenDlgProc(HWND hDlg, WORD iMessage,
				        WORD wParam, LONG lParam);

int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance,
		    LPSTR lpszCmdLine, int cmdShow)
{
    MSG msg;

    InitHdump(hInstance, hPrevInstance, lpszCmdLine, cmdShow);

    while (GetMessage(&msg, NULL, 0, 0)) {
	TranslateMessage(&msg);
	DispatchMessage(&msg);
    }

    return (msg.wParam);
}

void InitHdump(HANDLE hInstance, HANDLE hPrevInstance,
	        LPSTR lpszCmdLine, int cmdShow)
{
    if (!hPrevInstance)
	InitHdumpFirst(hInstance);
    else
	InitHdumpAdded(hPrevInstance);

    InitHdumpEvery(hInstance, cmdShow);
}

void InitHdumpFirst(HANDLE hInstance)
{
    WNDCLASS wcHdumpClass;

    wcHdumpClass.lpszClassName = szAppName;
    wcHdumpClass.hInstance = hInstance;
    wcHdumpClass.lpfnWndProc = HdumpWndProc;
    wcHdumpClass.hCursor = LoadCursor(NULL, IDC_ARROW);
    wcHdumpClass.hIcon = LoadIcon(hInstance, szAppName);
    wcHdumpClass.lpszMenuName = szAppName;
    wcHdumpClass.hbrBackground = GetStockObject(WHITE_BRUSH);
    wcHdumpClass.style = CS_HREDRAW | CS_VREDRAW;
    wcHdumpClass.cbClsExtra = 0;
    wcHdumpClass.cbWndExtra = 0;

    RegisterClass(&wcHdumpClass);
}

void InitHdumpAdded(HANDLE hPrevInstance)
{
}

void InitHdumpEvery(HANDLE hInstance, int cmdShow)
{
    TEXTMETRIC tm;
    HDC hDC;

    hInst = hInstance;

    hWndMain = CreateWindow(
			       szAppName,
			       szAppName,
			       WS_OVERLAPPEDWINDOW |
			       WS_HSCROLL |
			       WS_VSCROLL,
			       CW_USEDEFAULT,
			       0,
			       CW_USEDEFAULT,
			       0,
			       NULL,
			       NULL,
			       hInstance,
			       NULL
	);

    hDC = GetDC(hWndMain);

    cursfont.lfHeight = 6;
    cursfont.lfWidth = 6;
    cursfont.lfEscapement = 0;
    cursfont.lfOrientation = 0;
    cursfont.lfWeight = FW_NORMAL;
    cursfont.lfItalic = FALSE;
    cursfont.lfUnderline = FALSE;
    cursfont.lfStrikeOut = FALSE;
    cursfont.lfCharSet = ANSI_CHARSET;
    cursfont.lfOutPrecision = OUT_DEFAULT_PRECIS;
    cursfont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
    cursfont.lfQuality = DEFAULT_QUALITY;
    cursfont.lfPitchAndFamily = FIXED_PITCH | FF_DONTCARE;
    strcpy(cursfont.lfFaceName, "System");

    hnewsfont = CreateFontIndirect((LPLOGFONT) & cursfont);

    holdsfont = SelectObject(hDC, hnewsfont);

    GetTextMetrics(hDC, &tm);
    xChar = tm.tmAveCharWidth;
    yChar = tm.tmHeight + tm.tmExternalLeading;
    yCharnl = tm.tmHeight;

    ReleaseDC(hWndMain, hDC);

    ShowWindow(hWndMain, cmdShow);
    UpdateWindow(hWndMain);
}

void CloseHdump()
{
}

BOOL FAR PASCAL About(HWND hDlg, WORD message, WORD wParam, LONG lParam)
{
    if (message == WM_INITDIALOG)
	return (TRUE);

    else if (message == WM_COMMAND) {
	switch (wParam) {
	case IDOK:
	    EndDialog(hDlg, TRUE);
	    return (TRUE);

	default:
	    return (TRUE);
	}
    }
    return (FALSE);
}

long FAR PASCAL HdumpWndProc(HWND hWnd, WORD message,
			      WORD wParam, LONG lParam)
{
    static char sztFilePath[64];
    static char sztFileExt[5];
    static char sztFileSpec[64];
    static char sztFileName[64];

    FARPROC lpproc;
    char buf[128];
    int i;
    FILE *fh;

    switch (message) {
    case WM_CREATE:
	getcwd(sztFilePath, sizeof(sztFilePath));
	strcat(sztFilePath, "\\");
	strcpy(sztFileExt, ".*");
	strcpy(sztFileName, "");

	return (DefWindowProc(hWnd, message, wParam, lParam));

    case WM_COMMAND:
	switch (wParam) {
	case IDM_QUIT:
	    PostMessage(hWnd, WM_CLOSE, 0, 0L);
	    break;

	case IDM_HOME:
	    SendMessage(hWnd, WM_HSCROLL, SB_TOP, 0L);	/* not set up */
	    SendMessage(hWnd, WM_VSCROLL, SB_TOP, 0L);
	    break;

	case IDM_ABOUT:
	    lpproc = MakeProcInstance((FARPROC) About, hInst);
	    DialogBox(hInst,
		      MAKEINTRESOURCE(ABOUT),
		      hWnd,
		      lpproc);
	    FreeProcInstance(lpproc);
	    break;

	case IDM_OPEN:
	    strcpy(sztFileSpec, sztFilePath);
	    strcat(sztFileSpec, "*");
	    strcat(sztFileSpec, sztFileExt);

	    if (DoFileOpenDlg(hInst,
			      hWnd,
			      sztFileSpec,
			      sztFileExt,
			      0x4010,
			      sztFilePath,
			      sztFileName)) {
		strcpy(szFName, sztFilePath);
		strcat(szFName, sztFileName);

		sprintf(buf, "hdump - %s", szFName);
		SetWindowText(hWnd, buf);

		fh = fopen(szFName, "r+b");
		if (fh) {
		    fsize = filelength(fileno(fh));
		    numlines = (int) ((fsize + 16L - 1L) / 16L);
		    SnapLine(buf, szFName, 16, 16, NULL);
		    maxwidth = strlen(buf);
		    nVscrollPos = 0;
		    nHscrollPos = 0;

		    fclose(fh);
		} else {
		    SetWindowText(hWnd, "hdump");
		    numlines = 0;
		    maxwidth = 0;
		}

		SetupScroll(hWnd);

		InvalidateRect(hWnd, NULL, TRUE);
		UpdateWindow(hWnd);
	    }
	    break;

	default:
	    break;
	}
	break;

    case WM_SIZE:
	if (lParam) {
	    yClient = HIWORD(lParam);
	    xClient = LOWORD(lParam);

	    yClient = (yClient / yCharnl + 1) * yCharnl;

	    lParam = MAKELONG(xClient, yClient);

	    SetupScroll(hWnd);

	    return (DefWindowProc(hWnd, message, wParam, lParam));
	}
	break;

    case WM_VSCROLL:
	switch (wParam) {
	case SB_TOP:
	    nVscrollInc = -nVscrollPos;
	    break;

	case SB_BOTTOM:
	    nVscrollInc = nVscrollMax - nVscrollPos;
	    break;

	case SB_LINEUP:
	    nVscrollInc = -1;
	    break;

	case SB_LINEDOWN:
	    nVscrollInc = 1;
	    break;

	case SB_PAGEUP:
	    nVscrollInc = -max(1, yClient / yChar);
	    break;

	case SB_PAGEDOWN:
	    nVscrollInc = max(1, yClient / yChar);
	    break;

	case SB_THUMBPOSITION:
	    nVscrollInc = LOWORD(lParam) - nVscrollPos;
	    break;

	case SB_THUMBTRACK:
	    nVscrollInc = LOWORD(lParam) - nVscrollPos;
	    break;

	default:
	    nVscrollInc = 0;
	}

	nVscrollInc = max(-nVscrollPos,
			  min(nVscrollInc, nVscrollMax - nVscrollPos));
	if (nVscrollInc) {
	    nVscrollPos += nVscrollInc;
	    ScrollWindow(hWnd, 0, -yChar * nVscrollInc, NULL, NULL);
	    SetScrollPos(hWnd, SB_VERT, nVscrollPos, TRUE);
	    UpdateWindow(hWnd);
	}
	break;

    case WM_HSCROLL:
	switch (wParam) {
	case SB_LINEUP:
	    nHscrollInc = -1;
	    break;

	case SB_LINEDOWN:
	    nHscrollInc = 1;
	    break;

	case SB_PAGEUP:
	    nHscrollInc = -8;
	    break;

	case SB_PAGEDOWN:
	    nHscrollInc = 8;
	    break;

	case SB_THUMBPOSITION:
	    nHscrollInc = LOWORD(lParam) - nHscrollPos;
	    break;

	case SB_THUMBTRACK:
	    nHscrollInc = LOWORD(lParam) - nHscrollPos;
	    break;

	default:
	    nHscrollInc = 0;
	}

	nHscrollInc = max(-nHscrollPos,
			  min(nHscrollInc, nHscrollMax - nHscrollPos));
	if (nHscrollInc) {
	    nHscrollPos += nHscrollInc;
	    ScrollWindow(hWnd, -xChar * nHscrollInc, 0, NULL, NULL);
	    SetScrollPos(hWnd, SB_HORZ, nHscrollPos, TRUE);
	    UpdateWindow(hWnd);
	}
	break;

    case WM_KEYDOWN:
	for (i = 0; i < NUMKEYS; i++) {
	    if (wParam == key2scroll[i].wVirtkey) {
		SendMessage(hWnd, key2scroll[i].iMessage,
			    key2scroll[i].wRequest, 0L);
		break;
	    }
	}
	break;

    case WM_PAINT:
	HdumpPaint(hWnd);
	break;

    case WM_DESTROY:
	CloseHdump();
	PostQuitMessage(0);
	break;

    case WM_QUERYENDSESSION:
	CloseHdump();
	return ((long) TRUE);

    case WM_CLOSE:
	DestroyWindow(hWnd);
	break;

    default:
	return (DefWindowProc(hWnd, message, wParam, lParam));
    }

    return (0L);
}

void SetupScroll(HWND hWnd)
{
    nVscrollMax = max(0, numlines - yClient / yChar);
    nVscrollPos = min(nVscrollPos, nVscrollMax);

    nHscrollMax = max(0, maxwidth - xClient / xChar);
    nHscrollPos = min(nHscrollPos, nHscrollMax);

    SetScrollRange(hWnd, SB_VERT, 0, nVscrollMax, FALSE);
    SetScrollPos(hWnd, SB_VERT, nVscrollPos, TRUE);

    SetScrollRange(hWnd, SB_HORZ, 0, nHscrollMax, FALSE);
    SetScrollPos(hWnd, SB_HORZ, nHscrollPos, TRUE);

    nPageMaxLines = min(numlines, yClient / yChar);
}

void HdumpPaint(HWND hWnd)
{
    PAINTSTRUCT ps;
    HDC hDC;
    LONG offset;
    int tlen;
    int lpos;
    char buf[128];
    int i;
    int len;
    int hfile;
    HANDLE hbuff;
    LPSTR lpbuff;
    LPSTR lcp;

    hDC = BeginPaint(hWnd, (LPPAINTSTRUCT) & ps);

    SelectObject(hDC, hnewsfont);

    if (numlines) {
	if ((hfile = _lopen(szFName, OF_READ)) != -1) {
	    len = nPageMaxLines * 16;
	    hbuff = GlobalAlloc(GMEM_MOVEABLE, (DWORD) len);
	    if (hbuff) {
		lpbuff = GlobalLock(hbuff);
		if (lpbuff) {
		    offset = (LONG) nVscrollPos *16L;

		    if (_llseek(hfile, offset, 0) != -1L) {
			tlen = _lread(hfile, lpbuff, len);
			if (tlen != -1) {
			    lpos = 0;
			    lcp = lpbuff;

			    for (i = nVscrollPos; i < (nVscrollPos + nPageMaxLines); i++) {
				if (tlen > 16)
				    len = 16;
				else
				    len = tlen;
				tlen -= len;

				SnapLine(buf, lcp, len, 16, (char *) (i * 16));

				TextOut(hDC,
					xChar * (-nHscrollPos + 0),
					yChar * lpos++,
					buf,
					strlen(buf));

				lcp += 16;
			    }
			}
		    }
		    GlobalUnlock(hbuff);
		}
		GlobalFree(hbuff);
	    }
	    _lclose(hfile);
	}
    }
    EndPaint(hWnd, (LPPAINTSTRUCT) & ps);
}

char *SnapLine(char *szBuf, LPSTR mem, int len, int dwid, char *olbl)
{
    int i;
    int j;
    unsigned char c;
    unsigned char buff[80];
    unsigned char tbuf[80];

    if (len > dwid)
	len = dwid;

    *szBuf = 0;
    i = 0;
    j = 0;

    sprintf(tbuf, "%04X  ", olbl);
    strcpy(szBuf, tbuf);

    for (i = 0; i < len; i++) {
	c = *mem++;

	sprintf(tbuf, "%02X ", c);
	strcat(szBuf, tbuf);

	if (c >= 32 && c < 127)
	    buff[i] = c;
	else
	    buff[i] = 46;
    }

    j = dwid - i;

    buff[i] = 0;

    for (i = j; i > 0; i--)
	strcat(szBuf, "   ");

    sprintf(tbuf, " |%s|", buff);
    strcat(szBuf, tbuf);

    for (i = j; i > 0; i--)
	strcat(szBuf, " ");

    return (szBuf);
}

DoFileOpenDlg(HANDLE hInst, HWND hWnd,
	      char *szFileSpecIn, char *szDefExtIn,
	      WORD wFileAttrIn,
	      char *szFilePathOut, char *szFileNameOut)
{
    FARPROC lpfnFileOpenDlgProc;
    int iReturn;

    strcpy(szFileSpec, szFileSpecIn);
    strcpy(szDefExt, szDefExtIn);
    wFileAttr = wFileAttrIn;

    lpfnFileOpenDlgProc = MakeProcInstance((FARPROC) FileOpenDlgProc, hInst);

    iReturn = DialogBox(hInst,
			MAKEINTRESOURCE(OPENFILE),
			hWnd,
			lpfnFileOpenDlgProc);

    FreeProcInstance(lpfnFileOpenDlgProc);

    strcpy(szFilePathOut, szFilePath);
    strcpy(szFileNameOut, szFileName);

    return (iReturn);
}

BOOL FAR PASCAL FileOpenDlgProc(HWND hDlg, WORD iMessage,
				 WORD wParam, LONG lParam)
{
    static char curpath[64];

    char cLastChar;
    int nLen;
    struct find_t fileinfo;

    switch (iMessage) {
    case WM_INITDIALOG:
	getcwd(curpath, sizeof(curpath));

	SendDlgItemMessage(hDlg, IDD_FNAME, EM_LIMITTEXT, 80, 0L);

	DlgDirList(hDlg,
		   szFileSpec,
		   IDD_FLIST,
		   IDD_FPATH,
		   wFileAttr);

	SetDlgItemText(hDlg, IDD_FNAME, szFileSpec);
	return (TRUE);

    case WM_COMMAND:
	switch (wParam) {
	case IDD_FLIST:
	    switch (HIWORD(lParam)) {
	    case LBN_SELCHANGE:
		if (DlgDirSelect(hDlg, szFileName, IDD_FLIST))
		    strcat(szFileName, szFileSpec);
		SetDlgItemText(hDlg, IDD_FNAME, szFileName);
		break;

	    case LBN_DBLCLK:
		if (DlgDirSelect(hDlg, szFileName, IDD_FLIST)) {
		    strcat(szFileName, szFileSpec);
		    DlgDirList(hDlg, szFileName, IDD_FLIST, IDD_FPATH, wFileAttr);
		    SetDlgItemText(hDlg, IDD_FNAME, szFileSpec);
		} else {
		    SetDlgItemText(hDlg, IDD_FNAME, szFileName);
		    SendMessage(hDlg, WM_COMMAND, IDOK, 0L);
		}
		break;
	    }
	    break;

	case IDD_FNAME:
	    if (HIWORD(lParam) == EN_CHANGE) {
		EnableWindow(GetDlgItem(hDlg, IDOK),
			     (BOOL) SendMessage(LOWORD(lParam),
						WM_GETTEXTLENGTH, 0, 0L));
	    }
	    break;

	case IDOK:
	    GetDlgItemText(hDlg, IDD_FNAME, szFileName, 80);

	    nLen = strlen(szFileName);
	    cLastChar = *(szFileName + nLen - 1);

	    if (cLastChar == '\\' || cLastChar == ':')
		strcat(szFileName, szFileSpec);

	    if (strchr(szFileName, '*') || strchr(szFileName, '?')) {
		if (DlgDirList(hDlg, szFileName, IDD_FLIST, IDD_FPATH, wFileAttr)) {
		    strcpy(szFileSpec, szFileName);
		    SetDlgItemText(hDlg, IDD_FNAME, szFileSpec);
		} else
		    MessageBeep(0);
		break;
	    }
	    if (DlgDirList(hDlg, szFileName, IDD_FLIST, IDD_FPATH, wFileAttr)) {
		strcpy(szFileSpec, szFileName);
		SetDlgItemText(hDlg, IDD_FNAME, szFileSpec);
		break;
	    }
	    szFileName[nLen] = '\0';

	    if (_dos_findfirst(szFileName, 0, &fileinfo)) {
		strcat(szFileName, szDefExt);

		if (_dos_findfirst(szFileName, 0, &fileinfo)) {
		    MessageBeep(0);
		    break;
		}
	    }
	    GetDlgItemText(hDlg, IDD_FPATH, szFilePath, 80);
	    strupr(szFilePath);
	    if (szFilePath[strlen(szFilePath) - 1] != '\\')
		strcat(szFilePath, "\\");

	    strcpy(szFileName, fileinfo.name);

	    chdir(curpath);

	    EndDialog(hDlg, TRUE);
	    break;

	case IDCANCEL:
	    chdir(curpath);

	    EndDialog(hDlg, FALSE);
	    break;

	default:
	    return (FALSE);
	}
	break;

    default:
	return (FALSE);
    }

    return (TRUE);
}
