/*
ͻ
 What's it called: EPMGCC  V2.00                                              
                                                                              
 What does it do:  The E source code for the GCC-Interface for EPM.           
                   This file contains the code which changes global constants 
                   in order to use EPMGCC with the Borland C++ compiler.      
                   Compile this module, but don't include it into the base    
                   set of macros. It is intended to be used as an implicitly  
                   loaded module, executed from the command line (issue       
                   bccset from the command line and EPM will search in        
                   your paths for bccset.ex). See the documentation for       
                   details.                                                   
                                                                              
 Who and When:     B. Bablok 12/93 - 07/94                                    
                                                                              
ͼ
*/

TRYINCLUDE 'gccenv.e'
COMPILE IF not defined(GCC_MACRO_PATH)
   CONST   GCC_MACRO_PATH = '.\'          -- needed because of a bug in unlink
COMPILE ENDIF                             -- (better define it in gccenv.e)

DEFMAIN
  UNIVERSAL edit_command, compile_command, build_command, debug_command,
            gcc_d_comp_options, gcc_p_comp_options, gcc_d_make_options,
            gcc_p_make_options, want_translate, parser_module

  edit_command    = 'start /c /win epro'      -- makefile edit
  compile_command = 'start /n /win bcc'       -- compiler is bcc
  build_command   = 'start /n /win make'      -- use gnu-make
  debug_command   = 'start /n /pm /max td'    -- use turbo-debugger
  want_translate  = 1                         -- translate \ to / in filenames

  gcc_d_comp_options = '-c -v %*'
  gcc_p_comp_options = '-O2 -e%**P%**N.exe %*'
  gcc_d_make_options = '-k -f %* MODE=D'
  gcc_p_make_options = '-k -f %* MODE=P'

  'UNLINK' GCC_MACRO_PATH || parser_module    -- discard old error-parser
  'LINK    bccparse'                          -- bccparse.ex must be available
  parser_module = 'bccparse'                  -- save module-name
                                              -- UNLINK needs an absolute path
