/*
ͻ
 What's it called: EPMGCC  V2.00                                              
                                                                              
 What does it do:  The E source code for the GCC-Interface for EPM.           
                   This file contains the code for the error parser of        
                   compile time errors issued by ICC.                         
                   This module is linked seperately to allow the user to      
                   change the error-parser during runtime. See the            
                   documentation for details.                                 
                                                                              
 Who and When:     B. Bablok 12/93 - 07/94                                    
                                                                              
ͼ
*/
DEFC gcc_parse_error =
   UNIVERSAL gcc_error_file_id, gcc_other_file_id, gcc_error_file

   WHILE (.line <= .last) DO           -- iterate until a "true" error is found
     GETLINE  line

      IF POS(":",WORD(line,1)) = 0 THEN
         lineno = 'junk'
      ELSEIF SUBSTR(line,2,1) = ":" THEN
         PARSE VALUE line WITH drive ":" filename "(" lineno ":"  col ")" ":" . ":" gcc_message
         filename = drive":"filename
      ELSE
         PARSE VALUE line WITH filename "(" lineno ":"  col ")" ":" . ":" gcc_message
      ENDIF

     IF NOT ISNUM(lineno) THEN
       IF .line = .last THEN
          ACTIVATEFILE gcc_other_file_id
          SAYERROR "No more errors!"
          RETURN
       ELSE                           -- try the next line
         "+1"
       ENDIF
     ELSE                             -- found an error
       "EDIT" TRANSLATE(filename,'\','/') "'gcc_setpos "lineno col"'"
       SAYERROR gcc_message
       RETURN
     ENDIF
   ENDWHILE

DEFC gcc_setpos =
  .line = WORD(ARG(1),1)
  .col  = WORD(ARG(1),2)
